'''ground animals'''

from mob import *
from random import *

MINGEORGEDIST = 100.0

class Critter(Mob):
    def __init__(self, g, basename = 'badger', xpos = 400.0, ypos = 350.0):
        Mob.__init__(self, g, basename, xpos, ypos)
        self.type = 'critter'
        self.collidable = True
        self.xspeed = 0.0

    def _ai(self):
        if self.state == 'runaway':
            return
        if self.state == 'wait':
            newx = MINX + random() * (MAXX - MINX)
            if abs(self.g.scene.george.rect.centerx - newx) < MINGEORGEDIST:
                return
            self.xpos = newx
            self.rect.centerx = self.xpos
        if random() > 0.7:
            self.state = 'walk'
            if random() > 0.5:
                self.xspeed = -MOVESPEED
                self.direction = 0
            else:
                self.xspeed = MOVESPEED
                self.direction = 1
        else:
            self.state = 'stand'
            self.xspeed = 0.0
        self.timeremain = random() * MAXTIME + MINTIME
        self._setimage()

    def _process_state(self):
        if self.touchelevator == True:
            self.touchelevator = False
        elif self.falling == True:
            if self.ypos < CAVEY:
                self.ypos += FALLSPEED * self.dt / 1000.0
                self._setimage()
            else:
                self.falling = False
                self.ypos = CAVEY
        if self.state == 'runaway':
            self.xpos += self.xspeed * self.dt / 1000.0
            self.rect.centerx = self.xpos
            if self.xpos < -100.0 or self.xpos > 900.0:
                self.state = 'wait'
                self.timeremain = 5000.0 + random() * 20000.0
            return
        if self.state == 'walk':
            newx = self.xpos + self.xspeed * self.dt / 1000.0
            if newx < MINX or newx > MAXX:
                self.reverse()
                newx = self.xpos
            else:
                self.xpos = newx
            self.rect.midbottom = (self.xpos, self.ypos)

    def _animstate(self):
        if self.animstate == 'walk':
            self.animframe = self.animframe % 2 + 1
        self._setimage()

    def hitgeorge(self):
        if self.state == 'bite' or self.state == 'runaway':
            return
        self.g.scene.george.angry()
        self.state = 'bite'
        self.timeremain = 1000.0
