'''Display related functions'''

import os
import pygame
from pygame.locals import *

FIXED_X_RES = 800
FIXED_Y_RES = 600

def setup(g):
    '''Initialize and set up display'''
    g.screen = pygame.display.set_mode((FIXED_X_RES, FIXED_Y_RES), 
                                       HWSURFACE | DOUBLEBUF)
    pygame.display.set_caption("Pratfall!")
    # Change cursor to targeting reticule
    (head, tail) = os.path.split(__file__)
    cursorfile = os.path.join(os.path.split(head)[0], 
                              'data', 'miscgfx', 'reticule-cursor.xbm')
    maskfile = os.path.join(os.path.split(head)[0], 
                              'data', 'miscgfx', 'reticule-cursor-mask.xbm')
    cursor = pygame.cursors.load_xbm(cursorfile, maskfile)
    pygame.mouse.set_cursor(*cursor)
    




    
