'''Game main module'''

import pygame
from pygame.locals import *
import os
import util
import display
import resource
import targetpractice
import sound
import gameover

def main():
    pygame.mixer.pre_init(44100,-16,2, 1024)
    pygame.init()
    g = util.Generic()   # Global variables
    display.setup(g)
    g.res = resource.ResourceManager()
    g.snd = sound.SoundManager(g)
    g.level = 1
    g.scene = gameover.Gameover(g, 'title')
    g.scene.run()
    g.switch_to_scene = ''
    g.run = True
    bigloop(g)


def bigloop(g):
    '''Main loop'''
    lasttime = pygame.time.get_ticks()
    while g.run:
        if g.switch_to_scene != '':
            switch_scene(g)
        else:
            thistime = pygame.time.get_ticks()
            dt = thistime - lasttime
            lasttime = thistime
            g.scene.simstep(dt)
            g.scene.display()
            pygame.time.delay(10)

def switch_scene(g):
    g.snd.stopmusic()
    if g.switch_to_scene == 'gameover-lose':
        g.scene = gameover.Gameover(g, 'gameover-lose')
        g.scene.run()
    elif g.switch_to_scene == 'gameover-win':
        g.scene = gameover.Gameover(g, 'gameover-win')
        g.scene.run()
    elif g.switch_to_scene == 'playgame':
        g.scene = targetpractice.TargetPractice(g)
        g.scene.run()
    elif g.switch_to_scene == 'levelcomplete':
        g.scene = gameover.Gameover(g, 'levelcomplete')
        g.scene.run()
    else:
        print "unknown scene ", g.switch_to_scene
        exit
    g.switch_to_scene = ''
