'''shootable trigger'''

import pygame

class Trigger(pygame.sprite.Sprite):
    def __init__(self, g, actionitem, xpos, ypos):
        pygame.sprite.Sprite.__init__(self)
        self.g = g
        self.actionitem = actionitem
        self.state = 'off'
        self.basename = 'trigger'
        self.type = 'trigger'
        self.collidable = False
        self.xpos = xpos
        self.ypos = ypos
        self._setimage()

    def _setimage(self):
        self.image = self.g.res.images[self.basename + '-' + self.state]
        self.rect = self.image.get_rect()
        self.rect.midbottom = (self.xpos, self.ypos)

    def shot(self):
        if self.state == 'off':
            self.state = 'on'
            self.actionitem.trigger('on')
        else:
            self.state = 'off'
            self.actionitem.trigger('off')
        self._setimage()

